import { Component } from '../../view/functional/AbstractComponent';
export interface TagDefinition {
    inserted?: (component: Component) => void;
    removed?: (component: Component) => void;
    constructed?: (isSsr: boolean) => void;
    loadData?: () => boolean | Promise<boolean>;
    hydrated: boolean;
    template?: HTMLTemplateElement;
    tagName: string;
    tagFunction: () => Component;
    parameters?: any;
    templateUrl?: string;
}
export declare const register: (tagDef: TagDefinition, mode?: ShadowRootMode) => Promise<void>;
export declare const getTagDef: (tagName: string) => TagDefinition;
