import { AbstractCollectionComponent, AbstractItemView } from './AbstractCollectionComponent';
export declare type widthHeightObject = {
    width: number;
    height: number;
};
export declare const getScaleToFit: (objSize: widthHeightObject, sizeToFit: widthHeightObject) => number;
export interface ImageItem extends AbstractItemView {
    width: number;
    height: number;
    allowDrag: boolean;
    onThumbClick: (event: Event) => void;
    onDragStart: (event: Event) => void;
    onImageLoad: (event: Event) => void;
    setThumbnailSrc: (src: string) => void;
    removeEventListeners: () => void;
    model: {
        src: string;
    };
    render<T>(list?: Array<T>, isSsr?: boolean): HTMLElement;
    render(list?: Array<{
        src: string;
    }>, isSsr?: boolean): HTMLElement;
}
export interface ImageGallery extends AbstractCollectionComponent {
    title?: string;
}
export declare const createImageView: (component: AbstractItemView) => ImageItem;
export declare const createComponent: (component: AbstractCollectionComponent) => ImageGallery;
export declare const useImageView: () => ImageItem;
export declare const useImageGallery: () => ImageGallery;
